package model;

import org.apache.http.HttpEntity;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;

import java.io.IOException;

/*
  Klasa tworzaca klienta Http i wykonujaca zapytanie GET
*/

public class HttpClient {

    private CloseableHttpClient httpClient;

    public HttpClient() {
        this.httpClient = HttpClients.createDefault();
    }

    public HttpClient(CloseableHttpClient httpClient) {
        this.httpClient = httpClient;
    }

//    public void setHttpClient(CloseableHttpClient httpClient) {
//        this.httpClient = httpClient;
//    }

    public String executeGetRequest(String urlString) {

        HttpGet request = new HttpGet(urlString);

        try (CloseableHttpResponse response = httpClient.execute(request)) {
            HttpEntity entity = response.getEntity();
            if (entity != null) {
                return EntityUtils.toString(entity);
            }
            return "";
        } catch (ClientProtocolException e) {
            throw new RuntimeException(e);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}
