package org.example;

import model.*;

import java.io.IOException;
import java.util.*;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Objects;
import java.util.Scanner;

/*
  Klasa Main
*/

public class Main {
    public static void main(String[] args) throws IOException {

        String API_key = "4c991761f17e10358c944a3c64a3e24c";
        String fileCities = "cities.json";

        // utworzenie listy miast wraz z ich koordynatami
        JsonToMap jsonToMap = new JsonToMap();
        Map<String, Map<String, Double>> cityMap =
                jsonToMap.createCityMap(fileCities);

        CityNames cityNames = new CityNames();
        cityNames.cityNamesRead(fileCities);

        LocalDateTime czas = LocalDateTime.now();

        Scanner scanner = new Scanner(System.in);

        // utworzenie pustego pliku tymczasowego przechowujacego wyniki zapytan
        TemporaryFile temporaryFile = new TemporaryFile();
        temporaryFile.createEmptyFile();

        HttpClient httpClient = new HttpClient();

        ForecastPreparation forecastPreparation = new ForecastPreparation();
        System.out.println("Program rozpoczal dzialanie.");


        // glowna petla programu
        while (true) {

            System.out.println("Sprawdz pogode - y \n" +
                    "Zakoncz i zapisz wynik - z\n" +
                    "Wyjdz bez zapisywania - x");
            String input = scanner.nextLine().toLowerCase();

            // wyswietlenie prognozy dla wskazanego miasta
            if (Objects.equals(input, "y")) {
                System.out.println("Podaj nazwe miasta: ");
                String inputCity = scanner.nextLine().toLowerCase();
                if (cityMap.containsKey(inputCity)) {

                    Map<String, Double> specificCity = (Map<String, Double>) cityMap.get(inputCity);
                    double latitude = (double) specificCity.get("latitude");
                    double longitude = (double) specificCity.get("longitude");

                    // wygenerowanie odpowiedniego adresu url
                    String urlString = "https://api.openweathermap.org/data/2.5/weather?lat=" + latitude +
                            "&lon=" + longitude + "&appid=" + API_key;

                    String response = httpClient.executeGetRequest(urlString);

                    weatherForecast weatherForecast = forecastPreparation.fetchForecastData(inputCity, response);
                    String forecastString = weatherForecast.prepareForecastString();
                    System.out.println(forecastString);

                    // zapisanie prognozy do pliku tymczasowego
                    temporaryFile.addToFile(forecastString);

                } else {
                    System.out.println("Podanego miasta nie ma na liscie.");
                }
            // zapis wynikow
            } else if (Objects.equals(input, "z")) {

                System.out.println("W jakim formacie chcesz zapisac wyniki?\n pdf/json/xml");
                String whichFormat = scanner.nextLine().toLowerCase();

                // odczyt czasu na potrzeby wygenerowania nazwy pliku
                DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd_HHmmss");
                String sformatowanyCzas = czas.format(formatter);

                // zapis do pdf
                if (Objects.equals(whichFormat, "pdf")) {
                    String outputFile = "results/results" + sformatowanyCzas + ".pdf" ;
                    weatherForecast.saveToPdf(temporaryFile.FILE_NAME, outputFile);
                //zapis do json
                } else if (Objects.equals(whichFormat, "json")) {
                    String outputFile = "results/results" + sformatowanyCzas + ".json";
                    weatherForecast.saveToJson(outputFile);
                // zapis do xml
                } else if (Objects.equals(whichFormat, "xml")) {
                    String outputFile = "results/results" + sformatowanyCzas + ".xml";
                    weatherForecast.saveToXml(outputFile);
                } else {
                    System.out.println("Wprowadz poprawna opcje.");
                    continue;
                }
                System.out.println("Program zakonczyl dzialanie.");
                break;
            // wyjscie z programu
            } else if (Objects.equals(input,"x")) {
                System.out.println("Program zakonczyl dzialanie.");
                break;
            } else {
                System.out.println("Wprowadz poprawna opcje.");
            }
        }
    }
}
